﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using DataControlsInMVC.Models;

namespace DataControlsInMVC.Controllers
{
    public class EmployeeController : Controller
    {
        public ActionResult Index(SortingPagingData data)
        {
            DataClasses1DataContext db = new DataClasses1DataContext();
            IQueryable<Employee> emplist=null;
            emplist = from rows in db.Employees
                        select rows;

            if (data.SortField != null)
            {
                //sorting
                if (data.SortDirection == null)
                {
                    data.SortDirection = "asc";
                }

                switch (data.SortField.ToLower())
                {
                    case "id":
                        emplist = emplist.OrderByWithDirection(emp => emp.Id, data.SortDirection);
                        break;
                    case "name":
                        emplist = emplist.OrderByWithDirection(emp => emp.Name, data.SortDirection);
                        break;
                    default:
                        break;
                }

            }

            //paging
            data.PageSize = 2;
            if (data.PageSize > 0)
            {
                data.PageCount = emplist.Count() / data.PageSize;
                int start = (data.PageSize * data.PageNumber);
                emplist = emplist.Skip(start).Take(data.PageSize);
            }

            ViewData["emplist"]=emplist;
            ViewData["SortingPagingData"] = data;
            return View();
        }
        
        public ActionResult ShowInsertView()
        {
            return View();
        }

        [HttpPost]
        public ActionResult Insert(FormCollection collection)
        {
            DataClasses1DataContext db = new DataClasses1DataContext();
            Employee item = new Employee();
            item.Name = collection["DetailsView1$txtName"];
            item.Notes = collection["DetailsView1$txtNotes"];
            db.Employees.InsertOnSubmit(item);
            db.SubmitChanges();
            return RedirectToAction("Index");
        }

        public ActionResult ShowUpdateView(int id)
        {
            DataClasses1DataContext db=new DataClasses1DataContext();
            var temp = from item in db.Employees
                        where item.Id == id
                        select item;
            ViewData["emplist"] = temp.ToList();
            return View();
        }

        [HttpPost]
        public ActionResult Update(int id,FormCollection collection)
        {
            DataClasses1DataContext db = new DataClasses1DataContext();
            var temp = from item in db.Employees
                        where item.Id == id
                        select item;
            temp.First().Name=collection["DetailsView1$txtName"];
            temp.First().Notes = collection["DetailsView1$txtNotes"];
            db.SubmitChanges();
            return RedirectToAction("Index");
        }

        public ActionResult Delete(int id)
        {
            DataClasses1DataContext db = new DataClasses1DataContext();
            var temp = from item in db.Employees
                        where item.Id == id
                        select item;
            db.Employees.DeleteOnSubmit(temp.First());
            db.SubmitChanges();
            return RedirectToAction("Index");
        }
    }
}
