﻿<%@ Page Language="C#" Inherits="System.Web.Mvc.ViewPage<dynamic>" EnableViewState="false"  %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<script runat="server">

    protected void Page_Load(object sender, EventArgs e)
    {
        GridView1.DataSource = ViewData["emplist"];
        GridView1.DataBind();
    }

    protected override void SavePageStateToPersistenceMedium(object state)
    {
    }
    protected override object LoadPageStateFromPersistenceMedium()
    {
        return null;
    }

    protected void GridView1_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        DataControlsInMVC.SortingPagingData data = ViewData["SortingPagingData"] as DataControlsInMVC.SortingPagingData;
        string sortdir = "";
        if (data != null)
        {
            if (data.SortDirection == "asc")
                sortdir = "desc";
            else
                sortdir = "asc";
        }
        
        //sorting
        if (e.Row.RowType == DataControlRowType.Header)
        {
            HyperLink lnk1 = (HyperLink)e.Row.FindControl("lnkSortId");
            HyperLink lnk2 = (HyperLink)e.Row.FindControl("lnkSortName");

            lnk1.NavigateUrl = "~/employee/index?sortfield=id";
            if (data!=null && data.SortField == "id")
            {
                lnk1.NavigateUrl += "&sortdirection=" + sortdir;
            }
            lnk2.NavigateUrl = "~/employee/index?sortfield=name";
            if (data != null && data.SortField == "name")
            {
                lnk2.NavigateUrl += "&sortdirection=" + sortdir;
            }
        }
        
        //paging
        if (e.Row.RowType == DataControlRowType.Footer)
        {
            e.Row.Cells.Clear();
            TableCell pager = new TableCell();
            pager.ColumnSpan = 4;
            pager.HorizontalAlign=HorizontalAlign.Center;
            for(int i=0;i<data.PageCount;i++)
            {
                HyperLink lnk=new HyperLink();
                lnk.Text=(i+1).ToString();
                lnk.NavigateUrl= string.Format("~/employee/index?sortfield={0}&sortdirection={1}&pagenumber={2}",data.SortField,data.SortDirection,i);
                pager.Controls.Add(lnk);
                pager.Controls.Add(new LiteralControl("&nbsp;"));
            }
            e.Row.Cells.Add(pager);
        }
    }
</script>
<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Index</title>
</head>
<body>
    <form id="form1" runat="server">
        <asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="False" 
            CellPadding="6" DataKeyNames="Id" 
            ForeColor="#333333" EnableViewState="False" 
            onrowdatabound="GridView1_RowDataBound" PageSize="2" ShowFooter="True">
            <AlternatingRowStyle BackColor="White" ForeColor="#284775" />
            <Columns>
            <asp:TemplateField HeaderText="Id" InsertVisible="False" SortExpression="Id">
                <EditItemTemplate>
                    <asp:Label ID="Label1" runat="server" Text='<%# Eval("Id") %>'></asp:Label>
                </EditItemTemplate>
                <FooterTemplate>
                    <asp:PlaceHolder ID="PlaceHolder2" runat="server"></asp:PlaceHolder>
                </FooterTemplate>
                <HeaderTemplate>
                    <asp:HyperLink ID="lnkSortId" runat="server" ForeColor="White">Id</asp:HyperLink>
                </HeaderTemplate>
                <ItemTemplate>
                    <asp:Label ID="Label1" runat="server" Text='<%# Bind("Id") %>'></asp:Label>
                </ItemTemplate>
                <ItemStyle HorizontalAlign="Right" Width="60px" />
            </asp:TemplateField>
            <asp:TemplateField HeaderText="Name" SortExpression="Name">
                <EditItemTemplate>
                    <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("Name") %>'></asp:TextBox>
                </EditItemTemplate>
                <HeaderTemplate>
                    <asp:HyperLink ID="lnkSortName" runat="server" ForeColor="White">Name</asp:HyperLink>
                </HeaderTemplate>
                <ItemTemplate>
                    <asp:Label ID="Label2" runat="server" Text='<%# Bind("Name") %>'></asp:Label>
                </ItemTemplate>
                <ItemStyle Width="200px" />
            </asp:TemplateField>
                <asp:HyperLinkField DataNavigateUrlFields="Id" 
                    DataNavigateUrlFormatString="~/Employee/ShowUpdateView/{0}" 
                    Text="Edit" >
                </asp:HyperLinkField>
                <asp:HyperLinkField DataNavigateUrlFields="Id" 
                    DataNavigateUrlFormatString="~/Employee/Delete/{0}" Text="Delete" >
                </asp:HyperLinkField>
            </Columns>
            <EditRowStyle BackColor="#999999" />
            <FooterStyle BackColor="#999999" Font-Bold="True" ForeColor="White" />
            <HeaderStyle BackColor="#999999" Font-Bold="True" ForeColor="White" />
            <PagerStyle BackColor="#284775" ForeColor="White" HorizontalAlign="Center" />
            <PagerTemplate>
                <asp:PlaceHolder ID="PlaceHolder1" runat="server"></asp:PlaceHolder>
            </PagerTemplate>
            <RowStyle BackColor="#F7F6F3" ForeColor="#333333" />
            <SelectedRowStyle BackColor="#E2DED6" Font-Bold="True" ForeColor="#333333" />
            <SortedAscendingCellStyle BackColor="#E9E7E2" />
            <SortedAscendingHeaderStyle BackColor="#506C8C" />
            <SortedDescendingCellStyle BackColor="#FFFDF8" />
            <SortedDescendingHeaderStyle BackColor="#6F8DAE" />
        </asp:GridView>
    
        <br />

    <asp:HyperLink ID="HyperLink1" runat="server" Font-Bold="True" 
        NavigateUrl="~/Employee/ShowInsertView" EnableViewState="False">&nbsp;Add a new Employee&nbsp;</asp:HyperLink>
    </form>
</body>
</html>
